import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;

class ClippingFrame extends JFrame implements ItemListener{

    private DrawPanel drawPanel = new DrawPanel();
    private JCheckBox optShowCA = new JCheckBox("Show Clipping Area", false);
    private JCheckBox optClip = new JCheckBox("Clipping", false);
    private JCheckBox optDraw = new JCheckBox("Show Drawing", true);
    
    class DrawPanel extends JPanel {
   
      public DrawPanel() {
        setBackground(Color.lightGray);
      }
      
      public Dimension getPreferredSize() {
        return new Dimension(200, 150);
      }
    
      public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2 = (Graphics2D) g;
		// Construct base image
		Rectangle2D r = new Rectangle2D.Double(20, 50, 180, 50);
		// Construct clipping shape
		GeneralPath p = new GeneralPath();
        p.moveTo(50, 50);
        p.lineTo(70, 44);
        p.curveTo(100, 10, 140, 80, 160, 80);
        p.lineTo(190, 40);
        p.lineTo(200, 56);
        p.quadTo(100, 150, 70, 60);
        p.closePath();

        if (optShowCA.isSelected()) {
          g2.setPaint(Color.blue);
          g2.draw(p);
        };
        if (optClip.isSelected()) {
          g2.clip(p);
        };
        if (optDraw.isSelected()) {
          g2.setPaint(Color.red);
          g2.fill(r);
        };
      }
    }

	public ClippingFrame() {
	  setTitle("Clipping");
	  getContentPane().add(drawPanel,BorderLayout.NORTH);
      JPanel controlPanel = new JPanel();
	  getContentPane().add(controlPanel,BorderLayout.SOUTH);
	 	
      
      controlPanel.add(optShowCA);
      controlPanel.add(optClip);
      controlPanel.add(optDraw);
      optShowCA.addItemListener(this);
      optClip.addItemListener(this);
      optDraw.addItemListener(this);
	 	
      JButton exitButton = new JButton("Exit");
	  exitButton.addActionListener(new ActionListener(){
	    public void actionPerformed (ActionEvent event) {
          System.exit(0);
        }
	  });
	  controlPanel.add(exitButton);
	 	
	  addWindowListener(new WindowAdapter(){
	    public void windowClosing(WindowEvent we) {
          System.exit(0);
        }
      });
	 	
	  pack();
	  setVisible(true);
    }
    
    public void itemStateChanged(ItemEvent ie) {
      repaint();
    }
}

class Clipping {

  public static void main (String[] argv) {	
    ClippingFrame cf = new ClippingFrame();
  }
}
