import java.awt.*;
import java.awt.geom.*;
import java.awt.image.BufferedImage;
import java.io.*;

import com.sun.image.codec.jpeg.*;

public class TexturePaint2 extends Frame {

  public static void main(String[] args)  throws Exception {
    Frame f = new TexturePaint2("roa2.jpg");
    f.setSize(200, 200);
    f.setLocation(200, 200);
    f.setVisible(true);
  }
  
  private BufferedImage mImage;
  
  public TexturePaint2(String filename)
      throws IOException, ImageFormatException {
    // Load the specified JPEG file.
    InputStream in = getClass().getResourceAsStream(filename);
    JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(in);
    mImage = decoder.decodeAsBufferedImage();
    in.close();
}
  
  public void paint(Graphics g) {
    Graphics2D g2 = (Graphics2D)g;
    // Create a round rectangle.
    RoundRectangle2D r = new RoundRectangle2D.Float(25, 35, 150, 150, 25, 25);
    // Create a texture rectangle .
    Rectangle2D tr = new Rectangle2D.Double(0, 0, 20, 20);
    // Create the TexturePaint.
    TexturePaint tp = new TexturePaint(mImage, tr);
    // Now fill the round rectangle.
    g2.setPaint(tp);
    g2.fill(r);
  }
}
